#ifndef _CAMERA_FG_STD_CPP
#define _CAMERA_FG_STD_CPP

#include "camera_fg_std.h"

namespace ipl{ // use namespace in C++

using std::cout;
using std::endl;
using std::cerr;

CCameraFGStd::CCameraFGStd() : CCameraGeneric()
{
//	m_DeviceOpen=false;
}

CCameraFGStd::~CCameraFGStd()
{
	if(m_Initialized)
		Close();
//	if(m_DeviceOpen)
//		Close();
}

bool CCameraFGStd::Initialize(CFrameGrabberGeneric& fg, unsigned short portNr)
{
	m_pFrameGrabberGeneric = &fg;
	if (m_pFrameGrabberGeneric->AddCamera(portNr,*this))
	{
		m_Width=m_pFrameGrabberGeneric->GetWidth();
		m_Height=m_pFrameGrabberGeneric->GetHeight();
//		m_DeviceOpen = true;
		m_Initialized=true;
		return true;
	}
	else
	{
		m_pFrameGrabberGeneric=NULL;
		ostringstream ost;
		ost << "CCameraFGStd::Initialize() Failed adding camera to framegrabber" << IPLAddFileAndLine;
		CError::ShowMessage(IPL_ERROR,ost);
		m_Initialized=false;
		return false;
	}
}

bool CCameraFGStd::Initialize()
{
	ostringstream ost;
	ost << "Call CCameraFGStd::Initialize(CFrameGrabberGeneric& fg, unsigned short portNr) instead!!!" 
		<< IPLAddFileAndLine;
	CError::ShowMessage(IPL_ERROR,ost);
	return false;
}


bool CCameraFGStd::Acquire(ipl::CStdImage& Image)
{
	if (m_Initialized==false)
//	if (m_DeviceOpen==false)
	{
		ostringstream ost;
		ost << "CCameraFGStd::Acquire() Camera device not open" << IPLAddFileAndLine;
		CError::ShowMessage(IPL_ERROR,ost);
		return false;
	}
    if (m_pFrameGrabberGeneric->Acquire(Image, *this))
	{
		return true;
	}
	else
	{
		ostringstream ost;
		ost << "CCameraFGStd::Acquire() Acquire failed" << IPLAddFileAndLine;
		CError::ShowMessage(IPL_ERROR,ost);
		return false;
	}
}

bool CCameraFGStd::Close()
{
	if (IsInitialized())
//	if(m_DeviceOpen)
	{
		if(m_pFrameGrabberGeneric->IsDeviceOpen())
		{
			if(!m_pFrameGrabberGeneric->Close())
			{
				cerr << "Error: Unable to close framegrabber object" << endl;
				return false;
			}
		}
		m_Initialized=false;
//		m_DeviceOpen = false;
	}
	return true;
}

} // end namespace ipl

#endif //_CAMERA_FG_STD_CPP
