#ifndef _IPL98_PANASONIC_WVCD22_H
#define _IPL98_PANASONIC_WVCD22_H

#include "../../camera_ipl98_setup.h" /* always include the camera add-on library setup file */
#include <camera/camera_framegrabber/camera_fg_std.h> // defines the standard camera base class

namespace ipl{ // use namespace in C++

/** CPanasonicWVCD22 camera class. Developed with MS Visual C++ 6.0 but should work
	with other Window platforms such as Borland C++ Builder.
	last updated 02/13/2003.

	@version 0.12
	@author Mads Paulin */
class CPanasonicWVCD22 : public CCameraFGStd
{
public: // methods
	/** @name pure virtual functions from CCameraFGStd and CCameraGeneric, see base classes for additional info. */
	//@{
		/** Returns the string "CPanasonic WV-CD22" */
		string GetCameraName() const;
		/** Not available.
			@return False, always. */
		bool ShutterAvailable() const;
		/** Not available.
			@return False, always. */
		bool GainAvailable() const;
		/** Not available.
			@return False, always. */
		bool ZoomAvailable() const;
		/** Not available.
			@return False, always. */
		bool PartialScanAvailable() const;
	//@}

	
private:

};

} // end namespace ipl

#endif //_IPL98_PANASONIC_WVCD22_H