#ifndef _FRAMEGRABBERGENERIC_CPP
#define _FRAMEGRABBERGENERIC_CPP

#include "framegrabber_generic.h"

namespace ipl{ // use namespace in C++

CFrameGrabberGeneric::CFrameGrabberGeneric()
{
    for(int i=0; i<10; i++)
    {
        m_CameraList[i] = NULL;
    }
	m_DeviceOpen=false;
	m_DimensionsAvailable=false;
}

CFrameGrabberGeneric::~CFrameGrabberGeneric()
{
	if(m_DeviceOpen)
		Close();
}

bool CFrameGrabberGeneric::Open()
{
	m_DeviceOpen=true;
	return true;
}

bool CFrameGrabberGeneric::Close()
{
	m_DeviceOpen=false;
	return true;
}

bool CFrameGrabberGeneric::IsDeviceOpen()
{
	return m_DeviceOpen;
}

bool CFrameGrabberGeneric::AddCamera(unsigned short portNr, CCameraGeneric& Camera)
{
    if(m_CameraList[portNr]==NULL)
    {
        m_CameraList[portNr] = &Camera;
        return true;
    }
    return false;
}


bool CFrameGrabberGeneric::RemoveCamera(CCameraGeneric& Camera)
{
    for(int i=0; i<10; i++)
    {
        if(m_CameraList[i]==&Camera)
        {
            m_CameraList[i] = NULL;
            return true;
        }
    }
    return false;
}

bool CFrameGrabberGeneric::GetPortNumber(unsigned short& portNr, CCameraGeneric& Camera)
{
    for(int i=0; i<10; i++)
    {
        if(m_CameraList[i]==&Camera)
        {
            portNr = i;
            return true;
        }
    }
    return false;
}

} // end namespace ipl

#endif //_FRAMEGRABBERGENERIC_CPP
